Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3597)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3600)
@@ -657,62 +669,62 @@
 !------------------------------------------------------------------------------!
 
-    SUBROUTINE chem_boundary_conds( mode )                                           
-                                                                                     
-       USE control_parameters,                                                    &  
-          ONLY:  air_chemistry, bc_radiation_l, bc_radiation_n, bc_radiation_r,  &
-                 bc_radiation_s                
-       USE indices,                                                               &  
-          ONLY:  nxl, nxr,  nxlg, nxrg, nyng, nysg, nzt                              
-                                                                                     
-
-       USE arrays_3d,                                                             &     
-          ONLY:  dzu                                                
-       USE surface_mod,                                                           &
-          ONLY:  bc_h                                                           
-
-       CHARACTER (len=*), INTENT(IN) :: mode
-       INTEGER(iwp) ::  i                                                            !< grid index x direction.
-       INTEGER(iwp) ::  j                                                            !< grid index y direction.
-       INTEGER(iwp) ::  k                                                            !< grid index z direction.
-       INTEGER(iwp) ::  kb                                                           !< variable to set respective boundary value, depends on facing. 
-       INTEGER(iwp) ::  l                                                            !< running index boundary type, for up- and downward-facing walls.
-       INTEGER(iwp) ::  m                                                            !< running index surface elements.
-       INTEGER(iwp) ::  lsp                                                          !< running index for chem spcs.
-       INTEGER(iwp) ::  lph                                                          !< running index for photolysis frequencies
-
-
-       SELECT CASE ( TRIM( mode ) )        
-          CASE ( 'init' )
-
-             IF ( bc_cs_b == 'dirichlet' )    THEN
-                ibc_cs_b = 0 
-             ELSEIF ( bc_cs_b == 'neumann' )  THEN
-                ibc_cs_b = 1 
-             ELSE
-                message_string = 'unknown boundary condition: bc_cs_b ="' // TRIM( bc_cs_b ) // '"'  
-                CALL message( 'chem_boundary_conds', 'CM0429', 1, 2, 0, 6, 0 )     !<
-             ENDIF                                                                  
+ SUBROUTINE chem_boundary_conds( mode )                                           
+
+    USE control_parameters,                                                    &  
+        ONLY:  air_chemistry, bc_radiation_l, bc_radiation_n, bc_radiation_r,  &
+               bc_radiation_s                
+    USE indices,                                                               &  
+        ONLY:  nxl, nxr,  nxlg, nxrg, nyng, nysg, nzt                              
+
+    USE arrays_3d,                                                             &     
+        ONLY:  dzu                                                
+
+    USE surface_mod,                                                           &
+        ONLY:  bc_h                                                           
+
+    CHARACTER (len=*), INTENT(IN) ::  mode
+    INTEGER(iwp) ::  i                            !< grid index x direction.
+    INTEGER(iwp) ::  j                            !< grid index y direction.
+    INTEGER(iwp) ::  k                            !< grid index z direction.
+    INTEGER(iwp) ::  kb                           !< variable to set respective boundary value, depends on facing. 
+    INTEGER(iwp) ::  l                            !< running index boundary type, for up- and downward-facing walls.
+    INTEGER(iwp) ::  m                            !< running index surface elements.
+    INTEGER(iwp) ::  lsp                          !< running index for chem spcs.
+    INTEGER(iwp) ::  lph                          !< running index for photolysis frequencies
+
+
+    SELECT CASE ( TRIM( mode ) )        
+       CASE ( 'init' )
+
+          IF ( bc_cs_b == 'dirichlet' )    THEN
+             ibc_cs_b = 0 
+          ELSEIF ( bc_cs_b == 'neumann' )  THEN
+             ibc_cs_b = 1 
+          ELSE
+             message_string = 'unknown boundary condition: bc_cs_b ="' // TRIM( bc_cs_b ) // '"'  
+             CALL message( 'chem_boundary_conds', 'CM0429', 1, 2, 0, 6, 0 )     !<
+          ENDIF                                                                  
 !
 !--          Set Integer flags and check for possible erroneous settings for top
 !--          boundary condition. 
-             IF ( bc_cs_t == 'dirichlet' )             THEN
-                ibc_cs_t = 0 
-             ELSEIF ( bc_cs_t == 'neumann' )           THEN
-                ibc_cs_t = 1
-             ELSEIF ( bc_cs_t == 'initial_gradient' )  THEN
-                ibc_cs_t = 2
-             ELSEIF ( bc_cs_t == 'nested' )            THEN          
-                ibc_cs_t = 3
-             ELSE
-                message_string = 'unknown boundary condition: bc_c_t ="' // TRIM( bc_cs_t ) // '"'      
-                CALL message( 'check_parameters', 'CM0430', 1, 2, 0, 6, 0 )
-             ENDIF
-
-         
-          CASE ( 'set_bc_bottomtop' )                   
+          IF ( bc_cs_t == 'dirichlet' )             THEN
+             ibc_cs_t = 0 
+          ELSEIF ( bc_cs_t == 'neumann' )           THEN
+             ibc_cs_t = 1
+          ELSEIF ( bc_cs_t == 'initial_gradient' )  THEN
+             ibc_cs_t = 2
+          ELSEIF ( bc_cs_t == 'nested' )            THEN          
+             ibc_cs_t = 3
+          ELSE
+             message_string = 'unknown boundary condition: bc_c_t ="' // TRIM( bc_cs_t ) // '"'      
+             CALL message( 'check_parameters', 'CM0430', 1, 2, 0, 6, 0 )
+          ENDIF
+
+
+       CASE ( 'set_bc_bottomtop' )                   
 !--          Bottom boundary condtions for chemical species      
-             DO lsp = 1, nspec                                                      
-                IF ( ibc_cs_b == 0 ) THEN                   
-                   DO l = 0, 1 
+          DO lsp = 1, nspec                                                      
+             IF ( ibc_cs_b == 0 ) THEN                   
+                DO l = 0, 1 
 !--                Set index kb: For upward-facing surfaces (l=0), kb=-1, i.e.
 !--                the chem_species(nspec)%conc_p value at the topography top (k-1)
@@ -720,46 +732,46 @@
 !--                value at the topography bottom (k+1) is set. 
 
-                      kb = MERGE( -1, 1, l == 0 )
-                      !$OMP PARALLEL DO PRIVATE( i, j, k )
-                      DO m = 1, bc_h(l)%ns
-                         i = bc_h(l)%i(m)            
-                         j = bc_h(l)%j(m)
-                         k = bc_h(l)%k(m)
-                         chem_species(lsp)%conc_p(k+kb,j,i) = chem_species(lsp)%conc(k+kb,j,i) 
-                      ENDDO                                        
-                   ENDDO                                       
-             
-                ELSEIF ( ibc_cs_b == 1 ) THEN
+                   kb = MERGE( -1, 1, l == 0 )
+                   !$OMP PARALLEL DO PRIVATE( i, j, k )
+                   DO m = 1, bc_h(l)%ns
+                      i = bc_h(l)%i(m)            
+                      j = bc_h(l)%j(m)
+                      k = bc_h(l)%k(m)
+                      chem_species(lsp)%conc_p(k+kb,j,i) = chem_species(lsp)%conc(k+kb,j,i) 
+                   ENDDO                                        
+                ENDDO                                       
+
+             ELSEIF ( ibc_cs_b == 1 ) THEN
 !--             in boundary_conds there is som extra loop over m here for passive tracer
-                   DO l = 0, 1
-                      kb = MERGE( -1, 1, l == 0 )
-                      !$OMP PARALLEL DO PRIVATE( i, j, k )                                           
-                      DO m = 1, bc_h(l)%ns
-                         i = bc_h(l)%i(m)            
-                         j = bc_h(l)%j(m)
-                         k = bc_h(l)%k(m)
-                         chem_species(lsp)%conc_p(k+kb,j,i) = chem_species(lsp)%conc_p(k,j,i)
-
-                      ENDDO
+                DO l = 0, 1
+                   kb = MERGE( -1, 1, l == 0 )
+                   !$OMP PARALLEL DO PRIVATE( i, j, k )                                           
+                   DO m = 1, bc_h(l)%ns
+                      i = bc_h(l)%i(m)            
+                      j = bc_h(l)%j(m)
+                      k = bc_h(l)%k(m)
+                      chem_species(lsp)%conc_p(k+kb,j,i) = chem_species(lsp)%conc_p(k,j,i)
+
                    ENDDO
-                ENDIF
-          ENDDO    ! end lsp loop  
-
-!--    Top boundary conditions for chemical species - Should this not be done for all species?
-             IF ( ibc_cs_t == 0 )  THEN                    
-                DO lsp = 1, nspec
-                   chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc(nzt+1,:,:)        
-                ENDDO
-             ELSEIF ( ibc_cs_t == 1 )  THEN
-                DO lsp = 1, nspec
-                   chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc_p(nzt,:,:)
-                ENDDO
-             ELSEIF ( ibc_cs_t == 2 )  THEN
-                DO lsp = 1, nspec
-                   chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc_p(nzt,:,:) + bc_cs_t_val(lsp) * dzu(nzt+1)
                 ENDDO
              ENDIF
-!
-          CASE ( 'set_bc_lateral' )                       
+       ENDDO    ! end lsp loop  
+
+!--    Top boundary conditions for chemical species - Should this not be done for all species?
+          IF ( ibc_cs_t == 0 )  THEN                    
+             DO lsp = 1, nspec
+                chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc(nzt+1,:,:)        
+             ENDDO
+          ELSEIF ( ibc_cs_t == 1 )  THEN
+             DO lsp = 1, nspec
+                chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc_p(nzt,:,:)
+             ENDDO
+          ELSEIF ( ibc_cs_t == 2 )  THEN
+             DO lsp = 1, nspec
+                chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc_p(nzt,:,:) + bc_cs_t_val(lsp) * dzu(nzt+1)
+             ENDDO
+          ENDIF
+!
+       CASE ( 'set_bc_lateral' )                       
 !--             Lateral boundary conditions for chem species at inflow boundary
 !--             are automatically set when chem_species concentration is
@@ -770,25 +782,25 @@
 !--             Lateral boundary conditions for chem species at outflow boundary 
 
-             IF ( bc_radiation_s )  THEN
-                DO lsp = 1, nspec
-                   chem_species(lsp)%conc_p(:,nys-1,:) = chem_species(lsp)%conc_p(:,nys,:)
-                ENDDO
-             ELSEIF ( bc_radiation_n )  THEN
-                DO lsp = 1, nspec
-                   chem_species(lsp)%conc_p(:,nyn+1,:) = chem_species(lsp)%conc_p(:,nyn,:)
-                ENDDO
-             ELSEIF ( bc_radiation_l )  THEN
-                DO lsp = 1, nspec
-                   chem_species(lsp)%conc_p(:,:,nxl-1) = chem_species(lsp)%conc_p(:,:,nxl)
-                ENDDO
-             ELSEIF ( bc_radiation_r )  THEN
-                DO lsp = 1, nspec
-                   chem_species(lsp)%conc_p(:,:,nxr+1) = chem_species(lsp)%conc_p(:,:,nxr)
-                ENDDO
-             ENDIF
-            
-       END SELECT
-
-    END SUBROUTINE chem_boundary_conds
+          IF ( bc_radiation_s )  THEN
+             DO lsp = 1, nspec
+                chem_species(lsp)%conc_p(:,nys-1,:) = chem_species(lsp)%conc_p(:,nys,:)
+             ENDDO
+          ELSEIF ( bc_radiation_n )  THEN
+             DO lsp = 1, nspec
+                chem_species(lsp)%conc_p(:,nyn+1,:) = chem_species(lsp)%conc_p(:,nyn,:)
+             ENDDO
+          ELSEIF ( bc_radiation_l )  THEN
+             DO lsp = 1, nspec
+                chem_species(lsp)%conc_p(:,:,nxl-1) = chem_species(lsp)%conc_p(:,:,nxl)
+             ENDDO
+          ELSEIF ( bc_radiation_r )  THEN
+             DO lsp = 1, nspec
+                chem_species(lsp)%conc_p(:,:,nxr+1) = chem_species(lsp)%conc_p(:,:,nxr)
+             ENDDO
+          ENDIF
+
+    END SELECT
+
+ END SUBROUTINE chem_boundary_conds
 
 !
@@ -799,153 +811,154 @@
 !> x-direction
 !-----------------------------------------------------------------------------
-    SUBROUTINE chem_boundary_conds_decycle (cs_3d, cs_pr_init )
-       USE pegrid,                                                             &
-                 ONLY: myid
-
-       IMPLICIT NONE 
-       INTEGER(iwp) ::  boundary !< 
-       INTEGER(iwp) ::  ee !<
-       INTEGER(iwp) ::  copied !< 
-       INTEGER(iwp) ::  i !< 
-       INTEGER(iwp) ::  j !< 
-       INTEGER(iwp) ::  k !< 
-       INTEGER(iwp) ::  ss !< 
-       REAL(wp), DIMENSION(nzb:nzt+1) ::  cs_pr_init
-       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  cs_3d
-       REAL(wp) ::  flag !< flag to mask topography grid points
-
-       flag = 0.0_wp
-
-       
-!--    Left and right boundaries
-       IF ( decycle_chem_lr  .AND.  bc_lr_cyc )  THEN
-
-          DO  boundary = 1, 2
-
-             IF ( decycle_method(boundary) == 'dirichlet' )  THEN
+ SUBROUTINE chem_boundary_conds_decycle( cs_3d, cs_pr_init )
+
+    USE pegrid,                                                             &
+        ONLY:  myid
+
+    IMPLICIT NONE 
+    INTEGER(iwp) ::  boundary  !< 
+    INTEGER(iwp) ::  ee        !<
+    INTEGER(iwp) ::  copied    !< 
+    INTEGER(iwp) ::  i         !< 
+    INTEGER(iwp) ::  j         !< 
+    INTEGER(iwp) ::  k         !< 
+    INTEGER(iwp) ::  ss        !< 
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  cs_pr_init
+    REAL(wp), DIMENSION(nzb:nzt+1, nysg:nyng, nxlg:nxrg) ::  cs_3d
+    REAL(wp) ::  flag !< flag to mask topography grid points
+
+    flag = 0.0_wp
+
+
+!-- Left and right boundaries
+    IF ( decycle_chem_lr  .AND.  bc_lr_cyc )  THEN
+
+       DO  boundary = 1, 2
+
+          IF ( decycle_method(boundary) == 'dirichlet' )  THEN
 !    
-!--             Initial profile is copied to ghost and first three layers          
-                ss = 1
-                ee = 0
-                IF ( boundary == 1  .AND.  nxl == 0 )  THEN
-                   ss = nxlg
-                   ee = nxl+2
-                ELSEIF ( boundary == 2  .AND.  nxr == nx )  THEN
-                   ss = nxr-2
-                   ee = nxrg
-                ENDIF
-
-                DO  i = ss, ee
-                   DO  j = nysg, nyng
-                      DO  k = nzb+1, nzt
-                         flag = MERGE( 1.0_wp, 0.0_wp,                            &
-                                       BTEST( wall_flags_0(k,j,i), 0 ) )
-                         cs_3d(k,j,i) = cs_pr_init(k) * flag
-                      ENDDO
+!--          Initial profile is copied to ghost and first three layers          
+             ss = 1
+             ee = 0
+             IF ( boundary == 1  .AND.  nxl == 0 )  THEN
+                ss = nxlg
+                ee = nxl+2
+             ELSEIF ( boundary == 2  .AND.  nxr == nx )  THEN
+                ss = nxr-2
+                ee = nxrg
+             ENDIF
+
+             DO  i = ss, ee
+                DO  j = nysg, nyng
+                   DO  k = nzb+1, nzt
+                      flag = MERGE( 1.0_wp, 0.0_wp,                            &
+                                    BTEST( wall_flags_0(k,j,i), 0 ) )
+                      cs_3d(k,j,i) = cs_pr_init(k) * flag
                    ENDDO
                 ENDDO
-
-           ELSEIF ( decycle_method(boundary) == 'neumann' )  THEN
-!
-!--             The value at the boundary is copied to the ghost layers to simulate
-!--             an outlet with zero gradient
-                ss = 1
-                ee = 0
-                IF ( boundary == 1  .AND.  nxl == 0 )  THEN
-                   ss = nxlg
-                   ee = nxl-1
-                   copied = nxl
-                ELSEIF ( boundary == 2  .AND.  nxr == nx )  THEN
-                   ss = nxr+1
-                   ee = nxrg
-                   copied = nxr
-                ENDIF
-
-                 DO  i = ss, ee
-                   DO  j = nysg, nyng
-                      DO  k = nzb+1, nzt
-                         flag = MERGE( 1.0_wp, 0.0_wp,                            &
-                                       BTEST( wall_flags_0(k,j,i), 0 ) )
-                        cs_3d(k,j,i) = cs_3d(k,j,copied) * flag
-                      ENDDO
+             ENDDO
+
+        ELSEIF ( decycle_method(boundary) == 'neumann' )  THEN
+!
+!--          The value at the boundary is copied to the ghost layers to simulate
+!--          an outlet with zero gradient
+             ss = 1
+             ee = 0
+             IF ( boundary == 1  .AND.  nxl == 0 )  THEN
+                ss = nxlg
+                ee = nxl-1
+                copied = nxl
+             ELSEIF ( boundary == 2  .AND.  nxr == nx )  THEN
+                ss = nxr+1
+                ee = nxrg
+                copied = nxr
+             ENDIF
+
+              DO  i = ss, ee
+                DO  j = nysg, nyng
+                   DO  k = nzb+1, nzt
+                      flag = MERGE( 1.0_wp, 0.0_wp,                            &
+                                    BTEST( wall_flags_0(k,j,i), 0 ) )
+                     cs_3d(k,j,i) = cs_3d(k,j,copied) * flag
                    ENDDO
                 ENDDO
-
-             ELSE
-                WRITE(message_string,*)                                           &
-                                    'unknown decycling method: decycle_method (', &
-                        boundary, ') ="' // TRIM( decycle_method(boundary) ) // '"'
-                CALL message( 'chem_boundary_conds_decycle', 'CM0431',           &
-                              1, 2, 0, 6, 0 )
+             ENDDO
+
+          ELSE
+             WRITE(message_string,*)                                           &
+                                 'unknown decycling method: decycle_method (', &
+                     boundary, ') ="' // TRIM( decycle_method(boundary) ) // '"'
+             CALL message( 'chem_boundary_conds_decycle', 'CM0431',           &
+                           1, 2, 0, 6, 0 )
+          ENDIF
+       ENDDO
+    ENDIF
+
+
+!-- South and north boundaries
+    IF ( decycle_chem_ns  .AND.  bc_ns_cyc )  THEN
+
+       DO  boundary = 3, 4
+
+          IF ( decycle_method(boundary) == 'dirichlet' )  THEN
+!    
+!--          Initial profile is copied to ghost and first three layers          
+             ss = 1
+             ee = 0
+             IF ( boundary == 3  .AND.  nys == 0 )  THEN
+                ss = nysg
+                ee = nys+2
+             ELSEIF ( boundary == 4  .AND.  nyn == ny )  THEN
+                ss = nyn-2
+                ee = nyng
              ENDIF
-          ENDDO
-       ENDIF
-
-       
-!--    South and north boundaries
-       IF ( decycle_chem_ns  .AND.  bc_ns_cyc )  THEN
-
-          DO  boundary = 3, 4
-
-             IF ( decycle_method(boundary) == 'dirichlet' )  THEN
-!    
-!--             Initial profile is copied to ghost and first three layers          
-                ss = 1
-                ee = 0
-                IF ( boundary == 3  .AND.  nys == 0 )  THEN
-                   ss = nysg
-                   ee = nys+2
-                ELSEIF ( boundary == 4  .AND.  nyn == ny )  THEN
-                   ss = nyn-2
-                   ee = nyng
-                ENDIF
-
-                DO  i = nxlg, nxrg
-                   DO  j = ss, ee
-                      DO  k = nzb+1, nzt
-                         flag = MERGE( 1.0_wp, 0.0_wp,                            &
-                                       BTEST( wall_flags_0(k,j,i), 0 ) )
-                         cs_3d(k,j,i) = cs_pr_init(k) * flag
-                      ENDDO
+
+             DO  i = nxlg, nxrg
+                DO  j = ss, ee
+                   DO  k = nzb+1, nzt
+                      flag = MERGE( 1.0_wp, 0.0_wp,                            &
+                                    BTEST( wall_flags_0(k,j,i), 0 ) )
+                      cs_3d(k,j,i) = cs_pr_init(k) * flag
                    ENDDO
                 ENDDO
-       
-       
-           ELSEIF ( decycle_method(boundary) == 'neumann' )  THEN
-!
-!--             The value at the boundary is copied to the ghost layers to simulate
-!--             an outlet with zero gradient
-                ss = 1
-                ee = 0
-                IF ( boundary == 3  .AND.  nys == 0 )  THEN
-                   ss = nysg
-                   ee = nys-1
-                   copied = nys
-                ELSEIF ( boundary == 4  .AND.  nyn == ny )  THEN
-                   ss = nyn+1
-                   ee = nyng
-                   copied = nyn
-                ENDIF
-
-                 DO  i = nxlg, nxrg
-                   DO  j = ss, ee
-                      DO  k = nzb+1, nzt
-                         flag = MERGE( 1.0_wp, 0.0_wp,                            &
-                                       BTEST( wall_flags_0(k,j,i), 0 ) )
-                         cs_3d(k,j,i) = cs_3d(k,copied,i) * flag
-                      ENDDO
+             ENDDO
+
+
+        ELSEIF ( decycle_method(boundary) == 'neumann' )  THEN
+!
+!--          The value at the boundary is copied to the ghost layers to simulate
+!--          an outlet with zero gradient
+             ss = 1
+             ee = 0
+             IF ( boundary == 3  .AND.  nys == 0 )  THEN
+                ss = nysg
+                ee = nys-1
+                copied = nys
+             ELSEIF ( boundary == 4  .AND.  nyn == ny )  THEN
+                ss = nyn+1
+                ee = nyng
+                copied = nyn
+             ENDIF
+
+              DO  i = nxlg, nxrg
+                DO  j = ss, ee
+                   DO  k = nzb+1, nzt
+                      flag = MERGE( 1.0_wp, 0.0_wp,                            &
+                                    BTEST( wall_flags_0(k,j,i), 0 ) )
+                      cs_3d(k,j,i) = cs_3d(k,copied,i) * flag
                    ENDDO
                 ENDDO
-
-             ELSE
-                WRITE(message_string,*)                                           &
-                                    'unknown decycling method: decycle_method (', &
-                        boundary, ') ="' // TRIM( decycle_method(boundary) ) // '"'
-                CALL message( 'chem_boundary_conds_decycle', 'CM0432',           &
-                              1, 2, 0, 6, 0 )
-             ENDIF
-          ENDDO
-       ENDIF
-    END SUBROUTINE chem_boundary_conds_decycle
+             ENDDO
+
+          ELSE
+             WRITE(message_string,*)                                           &
+                                 'unknown decycling method: decycle_method (', &
+                     boundary, ') ="' // TRIM( decycle_method(boundary) ) // '"'
+             CALL message( 'chem_boundary_conds_decycle', 'CM0432',           &
+                           1, 2, 0, 6, 0 )
+          ENDIF
+       ENDDO
+    ENDIF
+ END SUBROUTINE chem_boundary_conds_decycle
    !
 !------------------------------------------------------------------------------!
@@ -956,62 +969,65 @@
 !------------------------------------------------------------------------------!
 
-    SUBROUTINE chem_check_data_output( var, unit, i, ilen, k )
-
-
-       USE control_parameters,                                                 &
-          ONLY: data_output, message_string
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*) ::  unit     !<
-       CHARACTER (LEN=*) ::  var      !<
-
-       INTEGER(iwp) :: i, lsp
-       INTEGER(iwp) :: ilen
-       INTEGER(iwp) :: k
-
-       CHARACTER(len=16)    ::  spec_name
-
-       unit = 'illegal'
-
-       spec_name = TRIM(var(4:))             !< var 1:3 is 'kc_' or 'em_'.
-
-       IF ( TRIM(var(1:3)) == 'em_' )  THEN
-          DO lsp=1,nspec
-             IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name))   THEN
-                unit = 'mol m-2 s-1'
-             ENDIF
-             !-- It is possible to plant PM10 and PM25 into the gasphase chemistry code
-             !-- as passive species (e.g. 'passive' in GASPHASE_PREPROC/mechanisms):
-             !-- set unit to micrograms per m**3 for PM10 and PM25 (PM2.5)
-             IF (spec_name(1:2) == 'PM')   THEN
-                unit = 'kg m-2 s-1'
-             ENDIF
-          ENDDO
-
-       ELSE
-
-          DO lsp=1,nspec
-             IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name))   THEN
-                unit = 'ppm'
-             ENDIF
-!            It is possible  to plant PM10 and PM25 into the gasphase chemistry code 
-!            as passive species (e.g. 'passive' in GASPHASE_PREPROC/mechanisms):
-!            set unit to kilograms per m**3 for PM10 and PM25 (PM2.5)
-             IF (spec_name(1:2) == 'PM')   THEN  
-               unit = 'kg m-3'
-             ENDIF
-          ENDDO
-
-          DO lsp=1,nphot
-             IF (TRIM(spec_name) == TRIM(phot_frequen(lsp)%name))   THEN
-                unit = 'sec-1'
-             ENDIF
-          ENDDO
-       ENDIF
-
-
-       RETURN
-    END SUBROUTINE chem_check_data_output
+ SUBROUTINE chem_check_data_output( var, unit, i, ilen, k )
+
+
+    USE control_parameters,                                                 &
+        ONLY:  data_output, message_string
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=*) ::  unit     !<
+    CHARACTER (LEN=*) ::  var      !<
+
+    INTEGER(iwp) ::  i
+    INTEGER(iwp) ::  lsp
+    INTEGER(iwp) ::  ilen
+    INTEGER(iwp) ::  k
+
+    CHARACTER(len=16)    ::  spec_name
+
+    unit = 'illegal'
+
+    spec_name = TRIM(var(4:))             !< var 1:3 is 'kc_' or 'em_'.
+
+    IF ( TRIM(var(1:3)) == 'em_' )  THEN
+       DO lsp=1,nspec
+          IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name))   THEN
+             unit = 'mol m-2 s-1'
+          ENDIF
+          !
+          !-- It is possible to plant PM10 and PM25 into the gasphase chemistry code
+          !-- as passive species (e.g. 'passive' in GASPHASE_PREPROC/mechanisms):
+          !-- set unit to micrograms per m**3 for PM10 and PM25 (PM2.5)
+          IF (spec_name(1:2) == 'PM')   THEN
+             unit = 'kg m-2 s-1'
+          ENDIF
+       ENDDO
+
+    ELSE
+
+       DO lsp=1,nspec
+          IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name))   THEN
+             unit = 'ppm'
+          ENDIF
+!
+!--            It is possible  to plant PM10 and PM25 into the gasphase chemistry code 
+!--            as passive species (e.g. 'passive' in GASPHASE_PREPROC/mechanisms):
+!--            set unit to kilograms per m**3 for PM10 and PM25 (PM2.5)
+          IF (spec_name(1:2) == 'PM')   THEN  
+            unit = 'kg m-3'
+          ENDIF
+       ENDDO
+
+       DO lsp=1,nphot
+          IF (TRIM(spec_name) == TRIM(phot_frequen(lsp)%name))   THEN
+             unit = 'sec-1'
+          ENDIF
+       ENDDO
+    ENDIF
+
+
+    RETURN
+ END SUBROUTINE chem_check_data_output
 !
 !------------------------------------------------------------------------------!
@@ -1022,49 +1038,49 @@
 !------------------------------------------------------------------------------!
 
-    SUBROUTINE chem_check_data_output_pr( variable, var_count, unit, dopr_unit )
-
-       USE arrays_3d
-       USE control_parameters,                                                    &
-           ONLY: data_output_pr, message_string, air_chemistry
-       USE indices
-       USE profil_parameter
-       USE statistics
-
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*) ::  unit     !< 
-       CHARACTER (LEN=*) ::  variable !< 
-       CHARACTER (LEN=*) ::  dopr_unit
-       CHARACTER(len=16) ::  spec_name
-    
-       INTEGER(iwp) ::  var_count, lsp  !<
-       
-
-       spec_name = TRIM(variable(4:))    
-
-          IF (  .NOT.  air_chemistry )  THEN
-             message_string = 'data_output_pr = ' //                        &
-             TRIM( data_output_pr(var_count) ) // ' is not imp' // &
-                         'lemented for air_chemistry = .FALSE.'
-             CALL message( 'chem_check_parameters', 'CM0433', 1, 2, 0, 6, 0 )              
-
-          ELSE
-             DO lsp = 1, nspec
-                IF (TRIM( spec_name ) == TRIM( chem_species(lsp)%name ) ) THEN 
-                   cs_pr_count = cs_pr_count+1
-                   cs_pr_index(cs_pr_count) = lsp
-                   dopr_index(var_count) = pr_palm+cs_pr_count  
-                   dopr_unit  = 'ppm'
-                   IF (spec_name(1:2) == 'PM')   THEN
-                        dopr_unit = 'kg m-3'
-                   ENDIF
-                      hom(:,2, dopr_index(var_count),:) = SPREAD( zu, 2, statistic_regions+1 )
-                      unit = dopr_unit  
+ SUBROUTINE chem_check_data_output_pr( variable, var_count, unit, dopr_unit )
+
+    USE arrays_3d
+    USE control_parameters,                                                    &
+        ONLY:  air_chemistry, data_output_pr, message_string
+    USE indices
+    USE profil_parameter
+    USE statistics
+
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=*) ::  unit     !< 
+    CHARACTER (LEN=*) ::  variable !< 
+    CHARACTER (LEN=*) ::  dopr_unit
+    CHARACTER(len=16) ::  spec_name
+
+    INTEGER(iwp) ::  var_count, lsp  !<
+
+
+    spec_name = TRIM(variable(4:))    
+
+       IF (  .NOT.  air_chemistry )  THEN
+          message_string = 'data_output_pr = ' //                        &
+          TRIM( data_output_pr(var_count) ) // ' is not imp' // &
+                      'lemented for air_chemistry = .FALSE.'
+          CALL message( 'chem_check_parameters', 'CM0433', 1, 2, 0, 6, 0 )              
+
+       ELSE
+          DO lsp = 1, nspec
+             IF (TRIM( spec_name ) == TRIM( chem_species(lsp)%name ) ) THEN 
+                cs_pr_count = cs_pr_count+1
+                cs_pr_index(cs_pr_count) = lsp
+                dopr_index(var_count) = pr_palm+cs_pr_count  
+                dopr_unit  = 'ppm'
+                IF (spec_name(1:2) == 'PM')   THEN
+                     dopr_unit = 'kg m-3'
                 ENDIF
-             ENDDO
-          ENDIF
-
-    END SUBROUTINE chem_check_data_output_pr
+                   hom(:,2, dopr_index(var_count),:) = SPREAD( zu, 2, statistic_regions+1 )
+                   unit = dopr_unit  
+             ENDIF
+          ENDDO
+       ENDIF
+
+ END SUBROUTINE chem_check_data_output_pr
 
 !
